const AEM = require('./index');
const fetch = require('isomorphic-fetch');
const exec = require('./generatorExec');
require('colors');

const aem = new AEM('http://aem.bwinparty.corp', 4502, 'cashcade_runner', 'Ca$hcad3');

const termsNodes = require('./nodesToModify');

exec(function *() {
  const termsLen = termsNodes.length;
  for (let i = 0; i < termsLen; i++) {
    const termsPath = termsNodes[i];
    const cqPage = termsPath.split('/jcr:content/')[0];

    console.log(`${i} / ${termsLen}\t${cqPage}`.blue);
    const pageNode = yield aem.getNode(cqPage).catch(e => null);

    if (pageNode === null) {
      console.log(' - couldnt find page'.yellow);
      continue;
    }

    const jcrContent = yield pageNode.getChild('jcr:content');
    const props = yield jcrContent.getProperties();

    // console.log(props);

    if (props['cq:lastReplicatedBy'] === 'cashcade_runner') {
      console.log(' - Page already activated. Skipping'.blue);
      continue;
    }

    if (props['cq:lastReplicationAction'] !== 'Activate') {
      console.log(' - Page not already activated. Ignoring'.yellow);
      continue;
    }

    if (!props['cq:lastReplicated']) {
      console.log(' - Missing last replicated date, ignoring'.yellow);
      continue;
    }

    if (!props['cq:lastModified']) {
      console.log(' - Missing last modified date, ignoring'.yellow);
      continue;
    }

    const lastModified = new Date(props['cq:lastModified']);
    const lastReplicated = new Date(props['cq:lastReplicated']);

    if (isNaN(lastModified)) {
      console.log(` - Unparseable last modified date: ${props['cq:lastModified']}`.yellow);
      continue;
    }

    if (isNaN(lastReplicated)) {
      console.log(` - Unparseable last replicated date: ${props['cq:lastReplicated']}`.yellow);
      continue;
    }

    if (lastModified > lastReplicated) {
      console.log(` - Changes have been made since last replication by ${props['cq:lastModifiedBy']}`.red);
      continue;
    }

    /**
     * ACTIVATE PAGE
     */
    yield pageNode.activate();

    console.log(` - DONE`.green);
  }
});